c*-*
c*-* Copyright (C) 2000 Massimo Marchi and Piero Procacci
c*-* Full copyright notice at http://www.chim.unifi.it/orac/copyright4.0.html
c*-* Contact for info M. Marchi, CEA,  Gif Sur Yvette 91191 (FRANCE) 
c*-* Email:marchi@villon.saclay.cea.fr
c*-* 
      SUBROUTINE comp_neigh_vor(heavy_vor,beta,nato,ngrp,grppt,nnlpp
     &     ,cutoff_vor,xp0,yp0,zp0,xpg,ypg,zpg,co,iret,errmsg)

************************************************************************
*   Time-stamp: <98/03/21 08:20:07 marchi>                             *
*                                                                      *
*                                                                      *
*                                                                      *
*=========================n=============================================*
*                                                                      *
*              Author:  Massimo Marchi                                 *
*              CEA/Centre d'Etudes Saclay, FRANCE                      *
*                                                                      *
*              - Wed Jun 18 1997 -                                     *
*                                                                      *
************************************************************************

*---- This subroutine is part of the program ORAC ----*


*======================== DECLARATIONS ================================*

      IMPLICIT none

*----------------------------- ARGUMENTS ------------------------------*
      
      INTEGER nig_nnl,nnnlpp_vor,iret
      INTEGER nato,ngrp,grppt(2,*)
      INTEGER*2 nnlpp(*)
      REAL*8  xp0(*),yp0(*),zp0(*),xpg(*),ypg(*),zpg(*),co(3,3)
     &     ,cutoff_vor
      LOGICAL heavy_vor
      CHARACTER*7 beta(*)
      CHARACTER*80 errmsg

*----------------------- VARIABLES IN SCRATCH COMMON ------------------*

      INCLUDE 'parst.h'
      INCLUDE 'voronoi.h'

      INTEGER*2 index(max_neigh,m1),index1(max_neigh,m1)
      INTEGER indexa(max_neigh)
      REAL*8    rsq(max_neigh,m1),rsq1(max_neigh,m1),rsqa(max_neigh)
     &     ,xmap(m1),ymap(m1),zmap(m1)
      COMMON /rag1/ xmap,ymap,zmap,rsq,rsq1,rsqa,index,index1,indexa

*------------------------- LOCAL VARIABLES ----------------------------*

      REAL*8  rs,xgg,ygg,zgg,xpgi,ypgi,zpgi,xpi,ypi,zpi,xc,yc,zc,xg,yg
     &     ,zg,cutoff2
      INTEGER map,i,i1,j1,j,m,n,jj,mz

      INCLUDE 'pbc.h'

*----------------------- EXECUTABLE STATEMENTS ------------------------*

      iret=0
      cutoff2=cutoff_vor**2
      n=0
      DO i=1,ngrp
         m=nnlpp(1+n)
         xpgi=xpg(i)
         ypgi=ypg(i)
         zpgi=zpg(i)
         DO jj=1,m
            j=nnlpp(jj+1+n)
            xgg=xpgi-xpg(j)
            ygg=ypgi-ypg(j)
            zgg=zpgi-zpg(j)
            xmap(jj)=2.0D0*PBC(xgg)
            ymap(jj)=2.0D0*PBC(ygg)
            zmap(jj)=2.0D0*PBC(zgg)
         END DO
         IF(heavy_vor) THEN
            DO i1=grppt(1,i),grppt(2,i)
               index(1,i1)=0
               IF(beta(i1)(1:1) .NE. 'h') THEN
                  xpi=xp0(i1)
                  ypi=yp0(i1)
                  zpi=zp0(i1)
                  map=0
                  DO jj=1,m
                     j=nnlpp(jj+1+n)
                     DO j1=grppt(1,j),grppt(2,j)
                        IF(beta(j1)(1:1) .NE. 'h') THEN
                           xg=xpi-xp0(j1)-xmap(jj)
                           yg=ypi-yp0(j1)-ymap(jj)
                           zg=zpi-zp0(j1)-zmap(jj)
                           xc=co(1,1)*xg+co(1,2)*yg+co(1,3)*zg
                           yc=           co(2,2)*yg+co(2,3)*zg
                           zc=                      co(3,3)*zg
                           rs=xc*xc+yc*yc+zc*zc
                           IF(rs .LT. cutoff2) THEN
                              map=map+1
                              rsq(map,i1)=rs
                              index(map+1,i1)=j1
                           END IF
                        END IF
                     END DO
                     IF(map .GT. max_neigh) THEN
                        iret=1
                        errmsg=
     &' While counting neighbors, _MAX_NEIGH_ in config.h is '
     &//'too small. Abort'
                        WRITE(6,*) map
                        RETURN
                     END IF
                  END DO
                  
************************************************************************
*---- Include contributions from bonded interactions of the same group -
************************************************************************
                  
                  DO jj=1,ig_nnl(1,i1)
                     j=ig_nnl(1+jj,i1)
                     IF(beta(j)(1:1) .NE. 'h') THEN
                        map=map+1
                        IF(map .GT. max_neigh) THEN
                           iret=1
                           errmsg=
     &' While counting neighbors, _MAX_NEIGH_ in config.h is '
     &//'too small. Abort.'
                           WRITE(6,*) map,max_neigh
                           RETURN
                        END IF
                        xg=xpi-xp0(j)
                        yg=ypi-yp0(j)
                        zg=zpi-zp0(j)
                        xc=co(1,1)*xg+co(1,2)*yg+co(1,3)*zg
                        yc=           co(2,2)*yg+co(2,3)*zg
                        zc=                      co(3,3)*zg
                        rsq(map,i1)=xc*xc+yc*yc+zc*zc
                        index(map+1,i1)=j
                     END IF
                  END DO
                  index(1,i1)=map
               END IF
            END DO
         ELSE
            DO i1=grppt(1,i),grppt(2,i)
               xpi=xp0(i1)
               ypi=yp0(i1)
               zpi=zp0(i1)
               map=0
               DO jj=1,m
                  j=nnlpp(jj+1+n)
                  DO j1=grppt(1,j),grppt(2,j)
                     xg=xpi-xp0(j1)-xmap(jj)
                     yg=ypi-yp0(j1)-ymap(jj)
                     zg=zpi-zp0(j1)-zmap(jj)
                     xc=co(1,1)*xg+co(1,2)*yg+co(1,3)*zg
                     yc=           co(2,2)*yg+co(2,3)*zg
                     zc=                      co(3,3)*zg
                     rs=xc*xc+yc*yc+zc*zc
                     IF(rs .LT. cutoff2) THEN
                        map=map+1
                        rsq(map,i1)=rs
                        index(map+1,i1)=j1
                     END IF
                  END DO
                  IF(map .GT. max_neigh) THEN
                     iret=1
                     errmsg=
     &' While counting neighbors, _MAX_NEIGH_ in config.h is '
     &//'too small. Abort'
                     WRITE(6,*) map
                     RETURN
                  END IF
               END DO
               
************************************************************************
*---- Include contributions from bonded interactions of the same group -
************************************************************************
               
               DO jj=1,ig_nnl(1,i1)
                  j=ig_nnl(1+jj,i1)
                  map=map+1
                  IF(map .GT. max_neigh) THEN
                     iret=1
                     errmsg=
     &' While counting neighbors, _MAX_NEIGH_ in config.h is '
     &//'too small. Abort.'
                     WRITE(6,*) map,max_neigh
                     RETURN
                  END IF
                  xg=xpi-xp0(j)
                  yg=ypi-yp0(j)
                  zg=zpi-zp0(j)
                  xc=co(1,1)*xg+co(1,2)*yg+co(1,3)*zg
                  yc=           co(2,2)*yg+co(2,3)*zg
                  zc=                      co(3,3)*zg
                  rsq(map,i1)=xc*xc+yc*yc+zc*zc
                  index(map+1,i1)=j
               END DO
               index(1,i1)=map
            END DO
         END IF
         n=n+m+1
      END DO

*=======================================================================
*---  Add neighbors on the lower diagonal ------------------------------
*=======================================================================

      DO i1=1,nato
         index1(1,i1)=index(1,i1)
         DO j=1,index(1,i1)
            index1(j+1,i1)=index(j+1,i1)
            rsq1(j,i1)=rsq(j,i1)
         END DO
      END DO

      DO i1=1,nato
         m=index(1,i1)
         DO j=1,m
            j1=index(j+1,i1)
            mz=index1(1,j1)+1
            IF(mz .GT. max_neigh) THEN
               iret=1
               errmsg=
     &' While counting neighbors, _MAX_NEIGH_ in config.h is '
     &//'too small. Abort.'
               WRITE(6,*) i1,m,j1,mz,max_neigh
               RETURN
            END IF
            index1(1,j1)=mz
            index1(mz+1,j1)=i1
            rsq1(mz,j1)=rsq(j,i1)
         END DO
      END DO


*=======================================================================
*--- Order the neighbor atoms according to the ascending order ---------
*--- of distance from the atom i ---------------------------------------
*=======================================================================

      DO i1=1,nato
         m=index1(1,i1)
         IF(m .NE. 0) THEN
            CALL indexx(m,rsq1(1,i1),indexa)

*=======================================================================
*--- Take only the first max_neigh -------------------------------------
*=======================================================================

            IF(m .GT. maxpla) THEN
               DO jj=1,maxpla
                  nnlpp_vor(jj,i1)=index1(1+indexa(jj),i1)
               END DO
            ELSE
               DO jj=1,m
                  nnlpp_vor(jj,i1)=index1(1+indexa(jj),i1)
               END DO
               DO jj=m+1,maxpla
                  nnlpp_vor(jj,i1)=index1(1+indexa(m),i1)
               END DO
            END IF
         ELSE
            DO jj=1,maxpla
               nnlpp_vor(jj,i1)=0
            END DO
         END IF
         IF(m .NE. 0 .AND. m .LT. maxpla) THEN
            DO j=m+1,maxpla
               indexa(j)=indexa(m)
            END DO
         END IF
      END DO

  
*----------------- END OF EXECUTABLE STATEMENTS -----------------------*

      RETURN
      END
