c*-*
c*-* Copyright (C) 2000 Massimo Marchi and Piero Procacci
c*-* Full copyright notice at http://www.chim.unifi.it/orac/copyright4.0.html
c*-* Contact for info M. Marchi, CEA,  Gif Sur Yvette 91191 (FRANCE) 
c*-* Email:marchi@villon.saclay.cea.fr
c*-* 
      subroutine correc(vpx,vpy,vpz,fpx,fpy,fpz,mass,ntap,dt)

************************************************************************
*                                                                      *
*     CORREC advances or velocities for half time step or corrects     *
*     velocities al full time step.                                    *
*                                                                      *
************************************************************************

*======================= DECLARATIONS ==================================

      IMPLICIT none

*----------------------- ARGUMENTS -------------------------------------

      REAL*8       fpx(*),fpy(*),fpz(*)
      REAL*8       vpx(*),vpy(*),vpz(*)
      integer      ntap
      real*8       dt,mass(*)


*-------------------- LOCAL VARIABLES ----------------------------------

      INTEGER      i
      real*8       tfact

*==================== EXECUTABLE STATEMENTS ============================

*=======================================================================
*  advance atomic velocities
*=======================================================================

      do i=1,ntap
         tfact=0.5*dt/mass(i)
         vpx(i)=vpx(i) + fpx(i)*tfact
         vpy(i)=vpy(i) + fpy(i)*tfact
         vpz(i)=vpz(i) + fpz(i)*tfact
      end do  

      RETURN
      END
