c*-*
c*-* Copyright (C) 2000 Massimo Marchi and Piero Procacci
c*-* Full copyright notice at http://www.chim.unifi.it/orac/copyright4.0.html
c*-* Contact for info M. Marchi, CEA,  Gif Sur Yvette 91191 (FRANCE) 
c*-* Email:marchi@villon.saclay.cea.fr
c*-* 
      SUBROUTINE  mts_forces(rshell,xp0,yp0,zp0,xpg,ypg,zpg,xpcm,ypcm
     &     ,zpcm,mapnl,mapdn,nmapdn,ucns,ucos,virs,virsp,ucnp,ucop,ucnsp
     &     ,ucosp,fpx,fpy,fpz,stress,nnlppo,nnlppi)


************************************************************************
*                                                                      *
*     FORCES calls MTS_FORSLV,MTS_FORPW,MTS_FORPP,FINTRAPS             *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     Written by Piero Procacci, CECAM-ENS Lyon 1995                   *
*                                                                      *
*                                                                      *
************************************************************************


*======================= DECLARATIONS ==================================

      IMPLICIT none

*-------------------- VARIABLES IN COMMONS -----------------------------

      include 'parst.h'
      include 'cpropar.h'
      INCLUDE 'unit.h'

*----------------------- ARGUMENTS -------------------------------------

      CHARACTER*1  rshell
      REAL*8  xp0(*),yp0(*),zp0(*),fpx(*),fpy(*),fpz(*),xpg(*),ypg(*)
     &     ,zpg(*),xpcm(*),ypcm(*),zpcm(*),stress(3,3)
      REAL*8  ucnp,ucop,ucns,ucos,ucnsp,ucosp,virs,virsp

      INTEGER mapnl(*),mapdn(2,*),nmapdn(*)
      INTEGER*2 nnlppo(*),nnlppi(*)

*-------------------- DEFINITION OF AN EXTERNAL FUNCTION ---------------

      EXTERNAL  near0
      LOGICAL near0

*-------------------- LOCAL VARIABLES ----------------------------------

      REAL*8 ro,rto,ri,rti,rni

      INTEGER iz1,npp,m,n

*==================== EXECUTABLE STATEMENTS ============================

*=======================================================================
*     select cutoffs according to current value of SHELL
*=======================================================================

      if(rshell.eq.'u') then
         iz1=0
         ro=rcuth
         ri=rcuth
         rto=0.d0
         rti=rtolh
         rni=rneih
      endif
      if(rshell.eq.'h') then
         iz1=1
         if(rneih.lt.1.d-10) iz1=0
         ro=rcuth
         ri=rcutl
         rto=rtolh
         rti=rtoll
         rni=rneil
      endif
      if(rshell.eq.'l') then
         iz1=1
         ro=rcutl
         rto=rtoll
         ri=rcutm
         rti=rtolm
         rni=rneim
      end if   
      if(rshell.eq.'m') then
         iz1=1
         ro=rcutm
         rto=rtolm
         ri=0.d0
         rti=0.d0
         rni=0.d0
      end if   
      ucnp=0.d0
      ucop=0.d0
      ucns=0.d0
      ucos=0.d0
      virs=0.d0
      ucnsp=0.d0
      ucosp=0.d0
      DO m=1,3
         DO n=1,3
            stress(n,m)=0.0D0
         END DO
      END DO

      CALL mts_forpp(ss_index,xp0,yp0,zp0,xpg,ypg,zpg,chrge,nbtype
     &     ,type_table,m6,ntap,atomg,xpcm,ypcm,zpcm,groupp,atomp,co
     &     ,ecc12,ecc6,clewld,alphal,erfc_spline,erfc_bin,erfc_arr,mapnl
     &     ,ngrp,grppt,ucnp,ucns,ucnsp,ucop,ucos,ucosp,fpx,fpy,fpz
     &     ,stress,nnlppo,nnlppi,rni,ri,ro,rti,rto,pmass,iz1,npp
     &     ,rcut_corr)


      IF(iz1 .EQ. 0) THEN
         WRITE(kprint,10000) npp
      END IF

*================= END OF EXECUTABLE STATEMENTS ========================

10000 FORMAT('Neighbor Lists Dimensions     *neighbor(',i7,')* '/)
      RETURN
      END
