c*-*
c*-* Copyright (C) 2000 Massimo Marchi and Piero Procacci
c*-* Full copyright notice at http://www.chim.unifi.it/orac/copyright4.0.html
c*-* Contact for info M. Marchi, CEA,  Gif Sur Yvette 91191 (FRANCE) 
c*-* Email:marchi@villon.saclay.cea.fr
c*-* 
      SUBROUTINE mts_furier(xpb,ypb,zpb,xp0,yp0,zp0,xpcm,ypcm,zpcm,urcsp
     &     ,urcs,urcp,virsp,virs,virp,fpx,fpy,fpz,fsin14,gsin14,fsbend
     &     ,gsbend,fsbond,gsbond,fscnstr_slt,fscnstr_slv,coul_bnd_slt
     &     ,coul_bnd_slv,rsh,rshk,eer,virial,fudgec,tag_bndg)

************************************************************************
*                                                                      *
*     Transit routine : calls MTS_FURIWW, MTS_FURIPP, MTS_FURIPW,      *
*     FERFF, WATSELF, PME_FFT                                          *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     Written by Piero Procacci, CECAM-ENS Lyon 1995                   *
*                                                                      *
*                                                                      *
************************************************************************


*======================= DECLARATIONS ==================================

      IMPLICIT none

*----------------------- ARGUMENTS -------------------------------------

      INTEGER tag_bndg(*)
      REAL*8     xp0(*),yp0(*),zp0(*),fpx(*),fpy(*),fpz(*),xpb(*),ypb(*)
     &     ,zpb(*)
      REAL*8     urcsp,urcs,urcp,virsp,virs,virp,fsin14,gsin14,fsbend
     &     ,gsbend,fsbond,gsbond,fudgec,fscnstr_slt,fscnstr_slv
     &     ,coul_bnd_slt,coul_bnd_slv
      character*1 rsh,rshk
      REAL*8  xpcm(*),ypcm(*),zpcm(*)

c---  stuff for b-spline interpolation and FFT 

c---  non local stuff 
      
      REAL*8   virial(3,3),eer
      INTEGER  i,j

*---- VARIABLES IN INCLUDE --------------------------------------------*

      INCLUDE 'parst.h'
      INCLUDE 'cpropar.h'
      INCLUDE 'pme.h'
      REAL*8  fx(m1),fy(m1),fz(m1),fxx(m1,2),fyy(m1,2),fzz(m1,2)
      COMMON /rag1/ fx,fy,fz,fxx,fyy,fzz

      REAL*8  fsbond_slt,fsbend_slt,fsin14_slt,fsbond_slv,fsbend_slv
     &     ,fsin14_slv

*==== EXECUTABLE STATEMENTS: ==========================================*

   
c---------------------------------------------------------------------
c     PROTEIN alone or PROTEIN + SOLVENT
c---------------------------------------------------------------------

      DO i=1,3
         DO j=1,3
            virial(i,j)=0.0D0
         END DO
      END DO
      eer=0.0D0
      IF(rsh .NE. rshk) RETURN

      IF(.NOT. pme) THEN
         CALL furipp(ss_index,oc,xp0,yp0,zp0,chrge,ntap,atomp,grppt
     &        ,alphal,rkcut,volume,urcp,urcs,urcsp,xpcm,ypcm,zpcm,fpx
     &        ,fpy,fpz,co,virial)
      ELSE

*=======================================================================
*--- Call fft_pme                                                   ----
*=======================================================================
      
         call fft_pme(ntap,xp0,yp0,zp0,xpcm,ypcm,zpcm,chrge,co,oc
     &        ,volume,alphal,pme_order,nfft1,nfft2,nfft3,eer,fpx,fpy
     &        ,fpz,virial,atomp,grppt,pressure,rkcut)
      END IF 

      IF(remove_momentum) THEN
         CALL remove_mv(fpx,fpy,fpz,mass,ntap)
      END IF

*=======================================================================
*---- Compute stress tensor if coupling is by group --------------------
*=======================================================================

      CALL zeroa(fx,fy,fz,ntap,1)
      CALL zeroa(fxx(1,1),fyy(1,1),fzz(1,1),ntap,1)
      CALL zeroa(fxx(1,2),fyy(1,2),fzz(1,2),ntap,1)
      
c=====      subtract "intramolecular term" in the ZERO cell: 
c--         bonds

      CALL ferrf(ss_index,alphal,chrge,1.0D0,xpb,ypb,zpb,1,lstrtch
     &     ,lstretch,fsbond_slt,fsbond_slv,fx,fy,fz,erf_corr
     &     ,erf_arr_corr,delew,rlew)
      fsbond=fsbond_slt+fscnstr_slt
      coul_bnd_slv=fsbond_slv+fscnstr_slv
      coul_bnd_slt=fsbond_slt+fscnstr_slt
      
c--         bendings

      CALL ferrf_tag(ss_index,alphal,chrge,xpb,ypb,zpb,int13,int13p
     &     ,fsbend_slt,fsbend_slv,fxx,fyy,fzz,m1,tag_bndg,erf_corr
     &     ,erf_arr_corr,delew,rlew)
      coul_bnd_slt=coul_bnd_slt+fsbend_slt
      coul_bnd_slv=coul_bnd_slv+fsbend_slv
      fsbend=fsbend_slt

      DO i=1,ntap
         fx(i)=fx(i)+fxx(i,2)
         fy(i)=fy(i)+fyy(i,2)
         fz(i)=fz(i)+fzz(i,2)
      END DO
c---         torsions (fudged)
    
      CALL ferrf(ss_index,alphal,chrge,fudgec,xpb,ypb,zpb,1,int14,int14p
     &     ,fsin14_slt,fsin14_slv,fx,fy,fz,erf_corr,erf_arr_corr,delew
     &     ,rlew)
      fsin14=fsin14_slt
      coul_bnd_slv=coul_bnd_slv+fsin14_slv
      coul_bnd_slt=coul_bnd_slt+fsin14_slt

      IF(pressure .OR. cpress .AND. coupl_grp) THEN
         CALL comp_stress_bnd(ntap,atomp,virial,co,xpcm,ypcm,zpcm,fx
     &        ,fy,fz)
      END IF

      DO i=1,ntap
         fpx(i)=fpx(i)+fx(i)+fxx(i,1)
         fpy(i)=fpy(i)+fy(i)+fyy(i,1)
         fpz(i)=fpz(i)+fz(i)+fzz(i,1)
      END DO

      RETURN
      END
